function parseMd(content) {
    //var frontMatters = [];
    var blockCount;
    var preDataIndex;
    var parseBlockDiv;
    var preImgObject = { 'image': {} };
    var isNotFrontMatterCount = 0;
    var isAmpImgRange = false;
    var result = [];

    var rblocks = new Array();
    lineIdx = 1;
    foundImg = false;
    foundYT = false;
    foundTBL = false;
    crossLine = "";

    for (var line of content.split('\n')) {
        lineIdx++;
        if (isNotFrontMatterCount < 2) {
            frontMatters.push(line)
            if (line.includes('title: ')) {
                $('#ctitle').val(line.replace('title: ', '').replaceAll('\"', ''));
            }
            if (line.includes('date: ')) {
                //alert(line);
                $('#cdate').val(line.replace('date: ', '').replaceAll('\"', ''));
            }
            if (line.includes('draft: ')) {
                //alert(line);
                $('#cdraft').val(line.replace('draft: ', '').replaceAll('\"', ''));
                //console.log($('#cdraft').val());
                $('#cdraft').removeAttr('checked');
                if ($('#cdraft').val() == 'false')
                    $('#cdraft').prop('checked', true);
                /*
                if($('#cdraft').val() == 'true') 
                    $('#cdraft').removeAttr('checked');
                else
                    $('#cdraft').attr('checked','true');
                    */
            }
            if (line.includes('type: ')) {
                //alert(line);
                $('#ctype').val(line.replace('type: ', '').replaceAll('\"', ''));
            }
            if (line.includes('url: ')) {
                //alert(line);
                $('#curl').val(line.replace('url: ', '').replaceAll('\"', ''));
            }
            if (line.includes('image: ')) {
                //alert(line);
                $('#cimage').val(line.replace('image: ', '').replaceAll('\"', ''));
            }
            if (line.includes('description: ')) {
                //alert(line);
                $('#cdescription').val(line.replace('description: ', '').replaceAll('\"', '').replaceAll('<br>', '\r\n'));
            }
            if (line.includes('weight: ')) {
                //alert(line);
                $('#cweight').val(line.replace('weight: ', '').replaceAll('\"', ''));
            }
            if (line.includes('tag: ')) {
                //alert(line);
                $('#ctag').val(line.replace('tag: ', '').replaceAll('\"', ''));
            }
            if (line.includes('categories: ')) {
                //alert(line);
                $('#ccategories').val(line.replace('categories: ', '').replace('categories: ', '').replace(/\[|]/g, '').replace(/\"/g, ''));
            }
            if (line.includes('col1: ')) {
                //alert(line);
                $('#ccol1').val(line.replace('col1: ', '').replaceAll('\"', ''));
            }
            if (line.includes('col2: ')) {
                //alert(line);
                $('#ccol2').val(line.replace('col2: ', '').replaceAll('\"', ''));
            }
            if (line.includes('---')) {
                isNotFrontMatterCount += 1;
            }
            continue;
        }
        contentMatters.push(line)
        /*         if (line.toString().trim() == "") {
                    rblocks.push({ 'type': 'br', 'text': line });
                    continue;
                } */

        if (line.includes('---')) {
            rblocks.push({ 'type': 'hr', 'text': line });
            continue;
        }

        if (line.includes('###')) {
            rblocks.push({ 'type': 'title', 'text': line });
            continue;
        }

        if (line.includes('{{% chuz-div class=\"mt-5\" %}}')) {
            rblocks.push({ 'type': 'mt5', 'text': line });
            continue;
        }

        if (line.includes('<amp-img') || foundImg) {
            crossLine += line;
            foundImg = true;
            if (line.includes('</amp-img>')) {
                rblocks.push({ 'type': 'img', 'text': crossLine });
                foundImg = false;
                crossLine = "";
            }
            continue;
        }

        if (line.includes('<amp-youtube') || foundYT) {
            crossLine += line;
            foundYT = true;
            if (line.includes('</amp-youtube>')) {
                rblocks.push({ 'type': 'youtube', 'text': crossLine });
                foundYT = false;
                crossLine = "";
            }
            continue;
        }

        if (line.includes('<table') || foundTBL) {
            crossLine += line;
            foundTBL = true;
            if (line.includes('</table>')) {
                rblocks.push({ 'type': 'table', 'text': crossLine });
                foundTBL = false;
                crossLine = "";
            }
            continue;
        }

        rblocks.push({ 'type': 'para', 'text': line });
    }

    return rblocks
}

function GetMdHeader() {
    rContent = "";
    rContent += '---\n';
    rContent += 'title: "' + $('#ctitle').val() + '"\n';
    rContent += 'date: ' + $('#cdate').val() + '\n';
    rContent += 'draft: ' + (!$('#cdraft').is(':checked')) + '\n';
    rContent += 'type: "' + $('#ctype').val() + '"\n';
    rContent += 'url: "' + $('#curl').val() + '"\n';
    //mdContent += 'url: "' + $('#curl').val() + '"\n';
    rContent += 'image: "' + $('#cimage').val() + '"\n';
    if ($('#ctype').val() == "collection") {
        rContent += 'description: "' + $('#cdescription').val().replace(/\r?\n/g, '<br>') + '"\n';
        rContent += 'weight: ' + ($('#cweight').val() == 'undefined' ? "" : $('#cweight').val()) + '\n';
        rContent += 'tag: "' + ($('#ctag').val() == 'undefined' ? "" : $('#ctag').val()) + '"\n';
    }
    else if ($('#ctype').val() == "blog") {
        rContent += 'categories: ["' + $('#ccategories').val() + '"]\n';
        rContent += 'col1: "' + ($('#ccol1').val() == 'undefined' ? "" : $('#ccol1').val()) + '"\n';
        rContent += 'col2: "' + ($('#ccol2').val() == 'undefined' ? "" : $('#ccol2').val()) + '"\n';
    }
    rContent += '---\n';
    return rContent
}

const parseTitle = line => {
    var title = '';
    title = line.replace('### **', '');
    title = title.replace('**', '');
    if (title.includes('敘述')) {
        title = title.replace('<!-- ', '');
        title = title.replace('-->', '');
    }
    return title;
};

const parseAmpImg = line => {
    if (line.includes('alt')) {
        const altParameter = line.replace(/ |alt=|"/g, '');
        return { alt: altParameter };
    } else if (line.includes('src')) {
        const srcParameter = line.replace(/ |src=|"/g, '');
        return { src: srcParameter };
    } else if (line.includes('height')) {
        const heightParameter = line.replace(/ |height=|"/g, '');
        return { height: heightParameter };
    } else if (line.includes('width')) {
        const widthParameter = line.replace(/ |width=|"/g, '');
        return { width: widthParameter };
    } else if (line.includes('layout')) {
        const layoutParameter = line.replace(/ |layout=|"|>/g, '');
    }
}

function tableTextToArray(tableHtml) {
    tbl = document.createElement('table');
    tbl.innerHTML = tableHtml.replace('<table>', '').replace('</table>', '');
    var tableInfo = Array.prototype.map.call(tbl.querySelectorAll('tr'), function (tr) {
        return Array.prototype.map.call(tr.querySelectorAll('td'), function (td) {
            return td.innerHTML;
        });
    });
    return tableInfo;
}

function tableArrayToHtml(tableArray) {
    tbl = document.createElement('table');
    for (j = 0; j < tableArray.length; j++) {
        tr = document.createElement('tr');
        for (k = 0; k < tableArray[j].length; k++) {
            td = document.createElement('td');
            if (k == 0)
                td.style.width = "25%";
            td.innerHTML = tableArray[j][k];
            tr.appendChild(td);
        }
        tbl.appendChild(tr);
    }
    //alert(tbl.outerHTML.toString());
    return tbl.outerHTML.toString();
}

class MDParser {

    constructor(MDtext) {
        this.headerText = "";
        this.contentText = "";
        this.title = "";
        this.date = new Date();
        this.draft = true;
        this.type = "";
        this.url = "";
        this.image = "";
        this.description = "";
        this.weight = 1;
        this.tag = [];
        for (var line of MDtext.split('\n')) {
            //console.log(line);
        }
    }


}


